﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.UI.TreeView.LocalizationProvider;
using Telerik.WinControls.UI.Localization;

namespace TelerikLocalizationDemo
{
	public partial class ShapedForm1 : Telerik.WinControls.UI.ShapedForm
	{
		public ShapedForm1()
		{
			InitializeComponent();
			// Localize MessageBox
			RadMessageLocalizationProvider.CurrentProvider = new TelerikLocalizations.RadMessageBoxLocalization();

			// Localize TreeView
			RadTreeViewLocalizationProvider.CurrentProvider = new TelerikLocalizations.RadTreeViewLocalization();

			// Localize GridView
			RadGridLocalizationProvider.CurrentProvider = new TelerikLocalizations.RadGridLocalization();

			var tmpList = from item in System.IO.Directory.GetFiles("c:\\windows\\temp")
										select new System.IO.FileInfo(item);
			radGridView1.DataSource = tmpList.ToList();

            this.radRadioButton1.ToggleState = Telerik.WinControls.Enumerations.ToggleState.On;
		}

		private void radRadioButton_ToggleStateChanged(object sender, Telerik.WinControls.UI.StateChangedEventArgs args)
		{
			if (radRadioButton1.ToggleState == Telerik.WinControls.Enumerations.ToggleState.On)
			{
				//Set French
				Application.CurrentCulture = new System.Globalization.CultureInfo("fr-FR");
			}
			else if (radRadioButton2.ToggleState == Telerik.WinControls.Enumerations.ToggleState.On)
			{
				//Set English
				Application.CurrentCulture = new System.Globalization.CultureInfo("en-US");
			}
			else if (radRadioButton3.ToggleState == Telerik.WinControls.Enumerations.ToggleState.On)
			{
				//Set German
				Application.CurrentCulture = new System.Globalization.CultureInfo("de-DE");
			}
			//TODO: radTreeView1 : does not reload texts localizations!!

            // RadGridView should reload the strings
            this.radGridView1.GridElement.Update(Telerik.WinControls.UI.GridUINotifyAction.Reset);
		}

		private void radButton1_Click(object sender, EventArgs e)
		{
			RadMessageBox.Show("MessageBoxButtons.YesNoCancel demo :o)", "TelerikLocalizationDemo", MessageBoxButtons.YesNoCancel, RadMessageIcon.Question);
		}

		private void radButton2_Click(object sender, EventArgs e)
		{
			RadMessageBox.Show("MessageBoxButtons.AbortRetryIgnore demo :o)", "TelerikLocalizationDemo", MessageBoxButtons.AbortRetryIgnore, RadMessageIcon.Exclamation);
		}

		private void radButton3_Click(object sender, EventArgs e)
		{
			RadMessageBox.Show("MessageBoxButtons.OK demo :o)", "TelerikLocalizationDemo", MessageBoxButtons.OK, RadMessageIcon.Info);
		}
	}
}